/*
 * $Header: /var/lib/cvs/AirportEditor/src/com/greghawkes/flightgear/tools/airporteditor/UIAirportProperties.java,v 1.1.1.1 2008-06-04 13:59:36 gregh Exp $
 * Copyright 2008 Gregory D. Hawkes.
 *
 * This file is part of AirportEditor.
 *
 * AirportEditor is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * AirportEditor is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AirportEditor.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.greghawkes.flightgear.tools.airporteditor;

import java.io.File;
import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

import com.greghawkes.utils.StringUtils;

/**
 * Airport properties dialog box.
 * 
 * @author $Author: gregh $
 * @version $Id: UIAirportProperties.java,v 1.1.1.1 2008-06-04 13:59:36 gregh Exp $
 */
public class UIAirportProperties extends javax.swing.JDialog {

    private boolean isOkay;

    /** Creates new form UIAirportProperties */
    public UIAirportProperties(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        isOkay = false;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pnlAirport = new javax.swing.JPanel();
        lblDescription = new javax.swing.JLabel();
        txtDescription = new javax.swing.JTextField();
        lblBackground = new javax.swing.JLabel();
        txtBackground = new javax.swing.JTextField();
        btnBrowse = new javax.swing.JButton();
        lblIcaoCode = new javax.swing.JLabel();
        txtIcaoCode = new javax.swing.JTextField();
        btnCancel = new javax.swing.JButton();
        btnOkay = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(com.greghawkes.flightgear.tools.airporteditor.AirportEditor.class).getContext().getResourceMap(UIAirportProperties.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setModal(true);
        setName("Form"); // NOI18N

        pnlAirport.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("pnlAirport.border.title"))); // NOI18N
        pnlAirport.setName("pnlAirport"); // NOI18N

        lblDescription.setText(resourceMap.getString("lblDescription.text")); // NOI18N
        lblDescription.setName("lblDescription"); // NOI18N

        txtDescription.setText(resourceMap.getString("txtDescription.text")); // NOI18N
        txtDescription.setName("txtDescription"); // NOI18N

        lblBackground.setText(resourceMap.getString("lblBackground.text")); // NOI18N
        lblBackground.setName("lblBackground"); // NOI18N

        txtBackground.setText(resourceMap.getString("txtBackground.text")); // NOI18N
        txtBackground.setName("txtBackground"); // NOI18N

        btnBrowse.setText(resourceMap.getString("btnBrowse.text")); // NOI18N
        btnBrowse.setName("btnBrowse"); // NOI18N
        btnBrowse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBrowseActionPerformed(evt);
            }
        });

        lblIcaoCode.setText(resourceMap.getString("lblIcaoCode.text")); // NOI18N
        lblIcaoCode.setName("lblIcaoCode"); // NOI18N

        txtIcaoCode.setText(resourceMap.getString("txtIcaoCode.text")); // NOI18N
        txtIcaoCode.setName("txtIcaoCode"); // NOI18N

        javax.swing.GroupLayout pnlAirportLayout = new javax.swing.GroupLayout(pnlAirport);
        pnlAirport.setLayout(pnlAirportLayout);
        pnlAirportLayout.setHorizontalGroup(
            pnlAirportLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlAirportLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlAirportLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblIcaoCode, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(lblDescription, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(lblBackground, javax.swing.GroupLayout.Alignment.TRAILING))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlAirportLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlAirportLayout.createSequentialGroup()
                        .addComponent(txtBackground, javax.swing.GroupLayout.DEFAULT_SIZE, 321, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBrowse))
                    .addComponent(txtDescription, javax.swing.GroupLayout.DEFAULT_SIZE, 387, Short.MAX_VALUE)
                    .addComponent(txtIcaoCode, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        pnlAirportLayout.setVerticalGroup(
            pnlAirportLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlAirportLayout.createSequentialGroup()
                .addGroup(pnlAirportLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblIcaoCode)
                    .addComponent(txtIcaoCode, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlAirportLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblDescription)
                    .addComponent(txtDescription, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlAirportLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblBackground)
                    .addComponent(btnBrowse)
                    .addComponent(txtBackground, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        btnCancel.setText(resourceMap.getString("btnCancel.text")); // NOI18N
        btnCancel.setName("btnCancel"); // NOI18N
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        btnOkay.setText(resourceMap.getString("btnOkay.text")); // NOI18N
        btnOkay.setName("btnOkay"); // NOI18N
        btnOkay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOkayActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(pnlAirport, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnOkay)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnCancel)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {btnCancel, btnOkay});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlAirport, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnOkay, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(btnCancel, javax.swing.GroupLayout.Alignment.TRAILING))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
    isOkay = false;
    setVisible(false);
}//GEN-LAST:event_btnCancelActionPerformed

private void btnOkayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOkayActionPerformed
    StringBuffer buf = new StringBuffer();
    
    // Validate ICAO code
    String s = StringUtils.trimToNull(txtIcaoCode.getText());
    if (s == null) {
        buf.append("ICAO Code cannot be empty\n");
    }

    // Validate description
    s = StringUtils.trimToNull(txtDescription.getText());
    if (s == null) {
        buf.append("Description cannot be empty\n");
    }

    // Validate background image
    s = StringUtils.trimToNull(txtBackground.getText());
    if (s == null) {
        buf.append("You must select a background image\n");

    } else {
        File f = new File(s);
        if (!f.exists()) {
            buf.append("The background image does not exist\n");
        } else if (!f.isFile()) {
            buf.append("The background image is not a file\n");
        } else if (!f.canRead()) {
            buf.append("The background image is not readable\n");
        }
    }

    // Report any errors
    if (buf.length() > 0) {
        JOptionPane.showMessageDialog(this, buf.toString(), "Invalid", JOptionPane.ERROR_MESSAGE);
        return;
    }

    isOkay = true;
    setVisible(false);
}//GEN-LAST:event_btnOkayActionPerformed

private void btnBrowseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBrowseActionPerformed
    String[] extensions = ImageIO.getReaderFileSuffixes();
    FileFilter filter = new FileNameExtensionFilter("Image files", extensions);
    JFileChooser fc = new JFileChooser();
    fc.setFileFilter(filter);
    File f = null;
    String filename = StringUtils.trimToNull(txtBackground.getText());
    if (filename != null) {
        f = new File(filename);
        fc.setSelectedFile(f);
    }
    fc.setDialogTitle("Select file to open");
    int result = fc.showOpenDialog(this);
    if (result != JFileChooser.APPROVE_OPTION) {
        return;
    }

    f = fc.getSelectedFile();
    filename = f.getAbsolutePath();
    txtBackground.setText(filename);
}//GEN-LAST:event_btnBrowseActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnBrowse;
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnOkay;
    private javax.swing.JLabel lblBackground;
    private javax.swing.JLabel lblDescription;
    private javax.swing.JLabel lblIcaoCode;
    private javax.swing.JPanel pnlAirport;
    private javax.swing.JTextField txtBackground;
    private javax.swing.JTextField txtDescription;
    private javax.swing.JTextField txtIcaoCode;
    // End of variables declaration//GEN-END:variables

    public void setIcaoCode(String descr) {
        txtIcaoCode.setText(descr);
    }

    public String getIcaoCode() {
        return txtIcaoCode.getText();
    }

    public void setDescription(String descr) {
        txtDescription.setText(descr);
    }

    public String getDescription() {
        return txtDescription.getText();
    }

    public void setImageFilename(String imageFilename) {
        txtBackground.setText(imageFilename);
    }

    public String getImageFilename() {
        return txtBackground.getText();
    }

    public boolean isAccepted() {
        return isOkay;
    }

}

// ----- Revision History -----
// $Log: UIAirportProperties.java,v $
// Revision 1.1.1.1  2008-06-04 13:59:36  gregh
// File imported into CVS repository
//
