/*
 * $Header: /var/lib/cvs/AirportEditor/src/com/greghawkes/flightgear/tools/airporteditor/UIGateProperties.java,v 1.1.1.1 2008-06-04 13:59:36 gregh Exp $
 * Copyright 2008 Gregory D. Hawkes.
 *
 * This file is part of AirportEditor.
 *
 * AirportEditor is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * AirportEditor is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AirportEditor.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.greghawkes.flightgear.tools.airporteditor;

/**
 * Terminal Gate properties dialog box.
 * 
 * @author $Author: gregh $
 * @version $Id: UIGateProperties.java,v 1.1.1.1 2008-06-04 13:59:36 gregh Exp $
 */
public class UIGateProperties extends javax.swing.JDialog {

    /**
     * Creates new form UIGateProperties
     */
    public UIGateProperties(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        isOkayButton = false;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTextField1 = new javax.swing.JTextField();
        pnlProperties = new javax.swing.JPanel();
        txtType = new javax.swing.JLabel();
        cmbType = new javax.swing.JComboBox();
        lblSize = new javax.swing.JLabel();
        txtSize = new javax.swing.JSpinner();
        lblHeading = new javax.swing.JLabel();
        txtHeading = new javax.swing.JSpinner();
        lblAirlines = new javax.swing.JLabel();
        txtAirlines = new javax.swing.JTextField();
        lblName = new javax.swing.JLabel();
        txtName = new javax.swing.JTextField();
        btnOkay = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(com.greghawkes.flightgear.tools.airporteditor.AirportEditor.class).getContext().getResourceMap(UIGateProperties.class);
        jTextField1.setText(resourceMap.getString("jTextField1.text")); // NOI18N
        jTextField1.setName("jTextField1"); // NOI18N

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setAlwaysOnTop(true);
        setModal(true);
        setName("Form"); // NOI18N
        setResizable(false);

        pnlProperties.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("pnlProperties.border.title"))); // NOI18N
        pnlProperties.setName("pnlProperties"); // NOI18N

        txtType.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        txtType.setText(resourceMap.getString("txtType.text")); // NOI18N
        txtType.setName("txtType"); // NOI18N

        cmbType.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Gate", "Cargo", "Ramp", "Military", "General" }));
        cmbType.setName("cmbType"); // NOI18N

        lblSize.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lblSize.setText(resourceMap.getString("lblSize.text")); // NOI18N
        lblSize.setName("lblSize"); // NOI18N

        txtSize.setModel(new javax.swing.SpinnerNumberModel(50, 0, 100, 1));
        txtSize.setEditor(new javax.swing.JSpinner.NumberEditor(txtSize, ""));
        txtSize.setName("txtSize"); // NOI18N

        lblHeading.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lblHeading.setText(resourceMap.getString("lblHeading.text")); // NOI18N
        lblHeading.setName("lblHeading"); // NOI18N

        txtHeading.setModel(new javax.swing.SpinnerNumberModel(0, 0, 359, 5));
        txtHeading.setEditor(new javax.swing.JSpinner.NumberEditor(txtHeading, ""));
        txtHeading.setName("txtHeading"); // NOI18N

        lblAirlines.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lblAirlines.setText(resourceMap.getString("lblAirlines.text")); // NOI18N
        lblAirlines.setName("lblAirlines"); // NOI18N

        txtAirlines.setText(resourceMap.getString("txtAirlines.text")); // NOI18N
        txtAirlines.setName("txtAirlines"); // NOI18N

        lblName.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lblName.setText(resourceMap.getString("lblName.text")); // NOI18N
        lblName.setName("lblName"); // NOI18N

        txtName.setText(resourceMap.getString("txtName.text")); // NOI18N
        txtName.setName("txtName"); // NOI18N

        javax.swing.GroupLayout pnlPropertiesLayout = new javax.swing.GroupLayout(pnlProperties);
        pnlProperties.setLayout(pnlPropertiesLayout);
        pnlPropertiesLayout.setHorizontalGroup(
            pnlPropertiesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPropertiesLayout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addGroup(pnlPropertiesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblName, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(txtType, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(lblSize, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(lblHeading, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(lblAirlines, javax.swing.GroupLayout.Alignment.TRAILING))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlPropertiesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(txtName, javax.swing.GroupLayout.PREFERRED_SIZE, 115, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txtAirlines, javax.swing.GroupLayout.DEFAULT_SIZE, 393, Short.MAX_VALUE)
                    .addComponent(cmbType, javax.swing.GroupLayout.PREFERRED_SIZE, 138, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(pnlPropertiesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(txtHeading, javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(txtSize, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pnlPropertiesLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {lblAirlines, lblHeading, lblName, lblSize, txtType});

        pnlPropertiesLayout.setVerticalGroup(
            pnlPropertiesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlPropertiesLayout.createSequentialGroup()
                .addGroup(pnlPropertiesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblName)
                    .addComponent(txtName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlPropertiesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtType)
                    .addComponent(cmbType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlPropertiesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblSize)
                    .addComponent(txtSize, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlPropertiesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblHeading)
                    .addComponent(txtHeading, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlPropertiesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblAirlines)
                    .addComponent(txtAirlines, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        btnOkay.setText(resourceMap.getString("btnOkay.text")); // NOI18N
        btnOkay.setName("btnOkay"); // NOI18N
        btnOkay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOkayActionPerformed(evt);
            }
        });

        btnCancel.setText(resourceMap.getString("btnCancel.text")); // NOI18N
        btnCancel.setName("btnCancel"); // NOI18N
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(pnlProperties, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnOkay)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnCancel)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {btnCancel, btnOkay});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlProperties, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnOkay)
                    .addComponent(btnCancel))
                .addContainerGap(13, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnOkayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOkayActionPerformed
        isOkayButton = true;
        setVisible(false);
    }//GEN-LAST:event_btnOkayActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        isOkayButton = false;
        setVisible(false);
    }//GEN-LAST:event_btnCancelActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnOkay;
    private javax.swing.JComboBox cmbType;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JLabel lblAirlines;
    private javax.swing.JLabel lblHeading;
    private javax.swing.JLabel lblName;
    private javax.swing.JLabel lblSize;
    private javax.swing.JPanel pnlProperties;
    private javax.swing.JTextField txtAirlines;
    private javax.swing.JSpinner txtHeading;
    private javax.swing.JTextField txtName;
    private javax.swing.JSpinner txtSize;
    private javax.swing.JLabel txtType;
    // End of variables declaration//GEN-END:variables

    private boolean isOkayButton;

    public boolean isAccepted() {
        return isOkayButton;
    }

    public void setType(String type) {
        cmbType.setSelectedItem(type);
    }

    public String getType() {
        return (String) cmbType.getSelectedItem();
    }

    public void setAirlineCodes(String airlines) {
        txtAirlines.setText(airlines);
    }
    
    public String getAirlineCodes() {
        return txtAirlines.getText();
    }
    
    public void setHeading(int heading) {
        txtHeading.setValue(heading);
    }
    
    public double getHeading() {
        Integer val = (Integer) txtHeading.getValue();
        return val.doubleValue();
    }
    
    public void setGateSize(int size) {
        txtSize.setValue(size);
    }
    
    public int getGateSize() {
        Integer val = (Integer) txtSize.getValue();
        return val.intValue();
    }

    public void setGateName(String name) {
        txtName.setText(name);
    }
    
    public String getGateName() {
        return txtName.getText();
    }
    
}

// ----- Revision History -----
// $Log: UIGateProperties.java,v $
// Revision 1.1.1.1  2008-06-04 13:59:36  gregh
// File imported into CVS repository
//
