/*
 * $Header: /var/lib/cvs/AirportEditor/src/com/greghawkes/flightgear/tools/airporteditor/UITaxiwayProperties.java,v 1.1.1.1 2008-06-04 13:59:36 gregh Exp $
 * Copyright 2008 Gregory D. Hawkes.
 *
 * This file is part of AirportEditor.
 *
 * AirportEditor is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * AirportEditor is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AirportEditor.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.greghawkes.flightgear.tools.airporteditor;

/**
 * Taxipath properties dialog box.
 * 
 * @author $Author: gregh $
 * @version $Id: UITaxiwayProperties.java,v 1.1.1.1 2008-06-04 13:59:36 gregh Exp $
 */
public class UITaxiwayProperties extends javax.swing.JDialog {

    /** Creates new form UIGateProperties */
    public UITaxiwayProperties(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        isOkayButton = false;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        grpDirection = new javax.swing.ButtonGroup();
        btnOkay = new javax.swing.JButton();
        pnlTaxiway = new javax.swing.JPanel();
        optForward = new javax.swing.JRadioButton();
        lblDirection = new javax.swing.JLabel();
        optBoth = new javax.swing.JRadioButton();
        optBackward = new javax.swing.JRadioButton();
        btnCancel = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setAlwaysOnTop(true);
        setModal(true);
        setName("Form"); // NOI18N
        setResizable(false);

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(com.greghawkes.flightgear.tools.airporteditor.AirportEditor.class).getContext().getResourceMap(UITaxiwayProperties.class);
        btnOkay.setText(resourceMap.getString("btnOkay.text")); // NOI18N
        btnOkay.setName("btnOkay"); // NOI18N
        btnOkay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOkayActionPerformed(evt);
            }
        });

        pnlTaxiway.setBorder(javax.swing.BorderFactory.createTitledBorder(resourceMap.getString("pnlTaxiway.border.title"))); // NOI18N
        pnlTaxiway.setName("pnlTaxiway"); // NOI18N

        grpDirection.add(optForward);
        optForward.setText(resourceMap.getString("optForward.text")); // NOI18N
        optForward.setName("optForward"); // NOI18N

        lblDirection.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        lblDirection.setText(resourceMap.getString("lblDirection.text")); // NOI18N
        lblDirection.setName("lblDirection"); // NOI18N

        grpDirection.add(optBoth);
        optBoth.setText(resourceMap.getString("optBoth.text")); // NOI18N
        optBoth.setName("optBoth"); // NOI18N

        grpDirection.add(optBackward);
        optBackward.setText(resourceMap.getString("optBackward.text")); // NOI18N
        optBackward.setName("optBackward"); // NOI18N

        javax.swing.GroupLayout pnlTaxiwayLayout = new javax.swing.GroupLayout(pnlTaxiway);
        pnlTaxiway.setLayout(pnlTaxiwayLayout);
        pnlTaxiwayLayout.setHorizontalGroup(
            pnlTaxiwayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlTaxiwayLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblDirection)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlTaxiwayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(optBoth, javax.swing.GroupLayout.DEFAULT_SIZE, 159, Short.MAX_VALUE)
                    .addComponent(optForward, javax.swing.GroupLayout.DEFAULT_SIZE, 159, Short.MAX_VALUE)
                    .addComponent(optBackward, javax.swing.GroupLayout.DEFAULT_SIZE, 159, Short.MAX_VALUE))
                .addContainerGap())
        );
        pnlTaxiwayLayout.setVerticalGroup(
            pnlTaxiwayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlTaxiwayLayout.createSequentialGroup()
                .addGroup(pnlTaxiwayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(lblDirection)
                    .addComponent(optBoth))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(optForward)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(optBackward))
        );

        btnCancel.setText(resourceMap.getString("btnCancel.text")); // NOI18N
        btnCancel.setName("btnCancel"); // NOI18N
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(pnlTaxiway, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnOkay)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnCancel)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {btnCancel, btnOkay});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnlTaxiway, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnCancel)
                    .addComponent(btnOkay))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnOkayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnOkayActionPerformed
        isOkayButton = true;
        setVisible(false);
    }//GEN-LAST:event_btnOkayActionPerformed

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        isOkayButton = false;
        setVisible(false);
    }//GEN-LAST:event_btnCancelActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnOkay;
    private javax.swing.ButtonGroup grpDirection;
    private javax.swing.JLabel lblDirection;
    private javax.swing.JRadioButton optBackward;
    private javax.swing.JRadioButton optBoth;
    private javax.swing.JRadioButton optForward;
    private javax.swing.JPanel pnlTaxiway;
    // End of variables declaration//GEN-END:variables

    private boolean isOkayButton;

    public boolean isAccepted() {
        return isOkayButton;
    }

    public void setDirection(int dir) {
        if (dir == TaxiPath.FORWARD) {
            optForward.setSelected(true);
        } else if (dir == TaxiPath.BACKWARD) {
            optBackward.setSelected(true);
        } else {
            optBoth.setSelected(true);
        }
    }

    public int getDirection() {
        if (optForward.isSelected()) {
            return TaxiPath.FORWARD;
        } else if (optBackward.isSelected()) {
            return TaxiPath.BACKWARD;
        } else {
            return TaxiPath.BOTH;
        }
    }

}

// ----- Revision History -----
// $Log: UITaxiwayProperties.java,v $
// Revision 1.1.1.1  2008-06-04 13:59:36  gregh
// File imported into CVS repository
//
